<?php

// QuickTicket 2.0 build:20090203

// --------

function AsImg($strSrc='',$strAlt='',$strTitle='',$strClass='',$strStyle='',$strHref='')
{
  if ( ArgTypeError('str',array($strSrc,$strAlt,$strTitle,$strClass,$strStyle,$strHref)) ) die('AsImg: Invalid argument type (expect string)');
  if ( empty($strSrc) ) return '';
  $strSrc = '<img src="'.$strSrc.'" alt="'.(!empty($strAlt) ? QTconv($strAlt) :'').'" title="'.(!empty($strTitle) ? QTconv($strTitle) :'').'"'.(!empty($strClass) ? ' class="'.$strClass.'"' : '').(!empty($strStyle) ? ' style="'.$strStyle.'"' : '').'/>';
  if ( empty($strHref) ) { return $strSrc; } else { return '<a href="'.$strHref.'">'.$strSrc.'</a>' ; }
}

// --------

function AsImgBox($strSrc='',$strClass='',$strStyle='',$strCaption='',$strHref='')
{
  if ( ArgTypeError('str',array($strSrc,$strClass,$strStyle,$strCaption,$strHref)) ) die('AsImgBox: Invalid argument type (expect string)');
  if ( !empty($strHref) ) $strCaption = '<a href="'.$strHref.'" class="small">'.$strCaption.'</a>';
  return '<div'.(empty($strClass) ? '' : ' class="'.$strClass.'"').(empty($strStyle) ? '' : ' style="'.$strStyle.'"').'>'.$strSrc.(empty($strCaption) ? '' : '<p class="imgcaption">'.$strCaption.'</p>').'</div>';
}

// --------

function HtmlHead($strRoot='',$strSkin='',$arrCss=null,$strHeadScript='',$bJava=true,$intBbc=0,$bIE=false)
{

if ( !is_array($arrCss) ) $arrCss=array();
if ( empty($strSkin) ) $strSkin = $_SESSION[QT]['skin_dir'];

echo QTI_HTML_DTD,'
<html xmlns="http://www.w3.org/1999/xhtml" dir="',QTI_HTML_DIR,'" xml:lang="',QTI_HTML_LANG,'">
<head>
<title>',$_SESSION[QT]['site_name'],'</title>
<meta http-equiv="content-type" content="text/html; charset=',QTI_HTML_CHAR,'"/>
<link rel="shortcut icon" href="',$strRoot,$strSkin,'/qti_icon.ico"/>
<link rel="stylesheet" type="text/css" href="',$strRoot,$strSkin,'/qti_main.css" title="cssmain"/>';

foreach ($arrCss as $strCss)
{
  if ( $strCss=='qti_contrast.css' )
  {
  echo '<link rel="alternate stylesheet" type="text/css" href="bin/qti_contrast.css" title="cssalternate"/>';
  }
  else
  {
  echo '<link rel="stylesheet" type="text/css" href="',$strRoot,$strSkin,'/',$strCss,'" title="cssmain"/>
  ';
  }
}

if ( !empty($strHeadScript) ) echo $strHeadScript;

if ( $intBbc>0 && $_SESSION[QT]['bbc']!='0' )
{
echo '
<script type="text/javascript">
<!--
';
include($strRoot.'bin/qti_j_bbc.js');
echo '
-->
</script>';
}
if ( $bJava )
{
echo '
<script type="text/javascript">
<!--
';
include($strRoot.'bin/qti_j_common.js');
echo '
-->
</script>';
}

if ( $bIE ) echo '
<!--[if IE 5]><style type="text/css">div.code{width:500px} .upper{text-transform:none;}</style><![endif]-->
<!--[if IE 6]><style type="text/css">div.code{width:500px} .upper{text-transform:none;}</style><![endif]-->
';

echo '
</head>
';

}

// --------

function HtmlPageCtrl($intType=0,$strWidth='')
{

if ( empty($strWidth) ) $strWidth=$_SESSION[QT]['site_width'];
switch ($intType)
{
case 0: echo '
<!-- PAGE CONTROL -->
<div class="qti_page">
<table class="qti_page" width="',$strWidth,'" cellspacing="0" cellpadding="0"><tr class="qti_page"><td class="qti_page">
<!-- PAGE CONTROL -->
';
break;
case 1: echo '
<!-- END PAGE CONTROL -->
</td></tr></table>
</div>
<!-- END PAGE CONTROL -->
';
break;
}

}

// --------

function HtmlBanner($intType=0,$strSkin='',$strLogo='',$strLangMenu='')
{

if ( empty($strSkin) ) $strSkin=$_SESSION[QT]['skin_dir'];
if ( empty($strLogo) ) $strLogo='qti_logo.gif';

switch ($intType)
{
case 0: echo '
<!-- HEADER BANNER -->
<div class="banner"><div class="banner_in">
<table class="hidden" cellspacing="0"><tr class="hidden">
<td class="hidden" id="banner_zl"><img id="banner_logo" src="',$strSkin,'/',$strLogo,'" alt="',$_SESSION[QT]['site_name'],'" title="',$_SESSION[QT]['site_name'],'"/></td>
<td class="hidden" id="banner_zr">',$strLangMenu,'</td>
</tr></table></div></div>
<!-- END HEADER BANNER -->
';
break;
case 1: echo '
<!-- HEADER NOBANNER -->
<table class="hidden" cellspacing="0"><tr class="hidden">
<td id="nobanner_zl">&nbsp;</td>
<td id="nobanner_zr">&nbsp;',$strLangMenu,'</td>
</tr></table>
<!-- END HEADER NOBANNER -->
';
break;
case 2: echo '
<!-- HEADER BANNER -->
<div class="banner">
<div class="banner_in">
<img src="',$strSkin,'/',$strLogo,'" width="175" height="50" style="border-width:0" alt="QuickTeam" title="QuickTeam"/>
</div>
</div>
<!-- END HEADER BANNER -->
';
break;
}

}

// --------

function HtmlPage($e=100)
{

/*
  0 BOARD OFF LINE
100 ACCESS DENIED
101 ACCESS RESTRICTED TO USERS
102 ACCESS RESTRICTED TO STAFF
*/

global $oVIP,$L,$oSYS;
include('qti_p_header.php');

switch($e)
{
case 0:
  $strFile = $_SESSION[QT]['language'].'/sys_offline.txt';
  if ( file_exists($strFile) ) { include($strFile); } else { echo '<h1>Board off-line</h1><p>The administrator has turned this board off-line.<br/>Please wait...</p>',"\n"; }
  break;
case 100: HtmlMsg(0); echo $L['E_access']; HtmlMsg(1); break;
case 101: HtmlMsg(0); echo $L['R_member']; HtmlMsg(1); break;
case 102: HtmlMsg(0); echo $L['R_staff'];  HtmlMsg(1); break;
default: echo '<p>Unknown trouble ['.strval($e).']</p>';
}

include('qti_p_footer.php');
exit;

}

// --------

function HtmlMsg($intType=0,$strWidth='',$strTitleId='',$strTitle='!',$strBodyId='',$strBody='')
{

if ( empty($strWidth) ) $strWidth='350px';

switch ($intType)
{
case 0: echo '
<div class="msgbox" style="width:',$strWidth,'">
<div class="msgboxtitle"',(empty($strTitleId) ? '' : ' id="'.$strTitleId.'"'),'>',$strTitle,'</div>
<div class="msgboxbody"',(empty($strBodyId) ? '' : ' id="'.$strBodyId.'"'),'>',(empty($strBody) ? '' : $strBody),'
';
break;
case 1: echo '
</div>
</div>
';
break;
}

}

// --------

function HtmlTabs($arrTabs=array(0=>'Empty'),$strUrl='', $strCurrent='',$intMax=6,$bFirst=true,$bLast=true,$strOnclick='')
{

// tabx means the last tab (can be special due to popup)
// if defined, the class/style tab_on replaces the class/style tab (but you can cumulate the classes in the definition)
// if defined, the class/style tabx_on replaces the class/style tabx (but you can cumulate the styles in the definition)

// When strCurrent is defined, this tab will not be clickable

$iCurrent=1;
foreach (array_keys($arrTabs) as $strKey)
{
  if ($strKey==$strCurrent) break;
  $iCurrent++;
}

// check

if ( !is_array($arrTabs) ) die('HtmlTabs: Argument #1 must be an array');
if ( !empty($strUrl) ) { if ( !strstr($strUrl,'?') ) $strUrl .= '?'; }

// display

echo'
<!-- tab header begin -->
<table cellspacing="0" class="ta_tab">
';

$strOuts=''; $strOut=''; $intRow=0; $intCol=0;
foreach ($arrTabs as $strKey=>$strTab)
{
  if ( $intCol==0 )
  {
    $strOut = '<tr class="tr_tab">'."\n";
    if ( $bFirst ) $strOut .= '<td class="td_tab'.($intRow==0 ? ' td_tab_begin' : ' hidden').'">&nbsp;</td>'."\n";
    $intCol++;
  }
  if ( $intCol>0 )
  {
    $strTabDesc = '';
    // strTab can be an array (as generated by cSection->GetTabs) instead of just the name
    if ( is_array($strTab) )
    {
      if ( isset($strTab['tabdesc']) )
      {
        if ( !empty($strTab['tabdesc']) ) $strTabDesc = $strTab['tabdesc'];
      }
      if ( isset($strTab['tabname']) )
      {
        if ( !empty($strTab['tabname']) ) { $strTab=$strTab['tabname']; } else { $strTab=ObjTrans('tab',$strKey); }
      }
      else
      {
        $strTab=ObjTrans('tab',$strKey);
      }
    }
    $strOut .= '<td class="td_tab td_tab_'.($strCurrent==$strKey ? 'on' : 'off').'_l">&nbsp;</td>';
    $strOut .= '<td class="td_tab td_tab_'.($strCurrent==$strKey ? 'on' : 'off').'_c">';
    if ( empty($strUrl) || $strCurrent==$strKey )
    {
    $strOut .= $strTab;
    }
    else
    {
    $strOut .=  '<a class="tab" href="'.$strUrl.'&amp;tt='.$strKey.'"'.(empty($strTabDesc) ? '' : ' title="'.$strTabDesc.'"').(empty($strOnclick) ? '' : ' onclick="'.$strOnclick).'">'.$strTab.'</a>';
    }
    $strOut .= '</td>';
    $strOut .= '<td class="td_tab td_tab_'.($strCurrent==$strKey ? 'on' : 'off').'_r">&nbsp;</td>'."\n";
    $intCol++; 
  }
  if ( $intCol>$intMax || $intCol>count($arrTabs) )
  {
    if ( $bLast ) $strOut .= '<td class="'.($intRow==0 ? 'td_tab td_tab_end' : 'hidden').'">&nbsp;</td>'."\n";
    $strOut .= '</tr>'."\n";
    $intCol = 0;
    $strOuts = $strOut.$strOuts;
    $intRow++;
  }
}
if ( $intCol>0 )
{
  while($intCol<=$intMax) { $strOut .= '<td class="td_tab td_tab_a">&nbsp;</td>'; $intCol++; }
  if ( $bLast ) $strOut .= '<td class="td_tab'.($intRow==0 ? ' td_tab_end' : ' hidden').'">&nbsp;</td>'."\n";
  $strOut .= '</tr>';
  $strOuts = $strOut.$strOuts;
}
echo $strOuts;

echo '
</table>
<!-- tab header end -->
';
}

?>